# class Chef::ConfigFetcher

### Attributes

config_file_jail[R]
config_location[R]

### Public Class Methods

new(config_location, config_file_jail=nil) click to toggle source

    # File lib/chef/config_fetcher.rb, line 12
    def initialize(config_location, config_file_jail=nil)
      @config_location = config_location
      @config_file_jail = config_file_jail
    end

### Public Instance Methods

config_missing?() click to toggle source

    # File lib/chef/config_fetcher.rb, line 48
    def config_missing?
      return false if remote_config?

      # Check if the config file exists, and check if it is underneath the config file jail
      begin
        real_config_file = Pathname.new(config_location).realpath.to_s
      rescue Errno::ENOENT
        return true
      end

      # If realpath succeeded, the file exists
      return false if !config_file_jail

      begin
        real_jail = Pathname.new(config_file_jail).realpath.to_s
      rescue Errno::ENOENT
        Chef::Log.warn("Config file jail #{config_file_jail} does not exist: will not load any config file.")
        return true
      end

      !Chef::ChefFS::PathUtils.descendant_of?(real_config_file, real_jail)
    end

fetch_json() click to toggle source

    # File lib/chef/config_fetcher.rb, line 17
    def fetch_json
      config_data = read_config
      begin
        Chef::JSONCompat.from_json(config_data)
      rescue JSON::ParserError => error
        Chef::Application.fatal!("Could not parse the provided JSON file (#{config_location}): " + error.message, 2)
      end
    end

fetch_remote_config() click to toggle source

    # File lib/chef/config_fetcher.rb, line 34
    def fetch_remote_config
      http.get("")
    rescue SocketError, SystemCallError, Net::HTTPServerException => error
      Chef::Application.fatal!("Cannot fetch config '#{config_location}': '#{error.class}: #{error.message}", 2)
    end

http() click to toggle source

    # File lib/chef/config_fetcher.rb, line 71
    def http
      Chef::HTTP::Simple.new(config_location)
    end

read_config() click to toggle source

    # File lib/chef/config_fetcher.rb, line 26
    def read_config
      if remote_config?
        fetch_remote_config
      else
        read_local_config
      end
    end

read_local_config() click to toggle source

    # File lib/chef/config_fetcher.rb, line 40
    def read_local_config
      ::File.read(config_location)
    rescue Errno::ENOENT => error
      Chef::Application.fatal!("Cannot load configuration from #{config_location}", 2)
    rescue Errno::EACCES => error
      Chef::Application.fatal!("Permissions are incorrect on #{config_location}. Please chmod a+r #{config_location}", 2)
    end

remote_config?() click to toggle source

    # File lib/chef/config_fetcher.rb, line 75
    def remote_config?
      !!(config_location =~ %r{^(http|https)://})
    end